"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.collectFileNames = void 0;
const path = __importStar(require("path"));
const glob_1 = require("./shared/glob");
const collectFileNames = async (argv, cwd, include) => {
    const globsAndNames = await collectFileNamesFromGlobs(argv, cwd, include);
    if (!globsAndNames) {
        return undefined;
    }
    const [fileGlobs, fileNames] = globsAndNames;
    const implicitNodeModulesInclude = implicitNodeModulesIncluded(fileGlobs, fileNames);
    if (implicitNodeModulesInclude) {
        return `At least one path including node_modules was included implicitly: '${implicitNodeModulesInclude}'. Either adjust TypeStat's included files to not include node_modules (recommended) or explicitly include node_modules/ (not recommended).`;
    }
    return fileNames;
};
exports.collectFileNames = collectFileNames;
const collectFileNamesFromGlobs = async (argv, cwd, include) => {
    if (argv.args !== undefined && argv.args.length !== 0) {
        return [argv.args, await glob_1.globAllAsync(argv.args)];
    }
    if (include === undefined) {
        return undefined;
    }
    return [include, await glob_1.globAllAsync(include.map((subInclude) => path.join(cwd, subInclude)))];
};
const implicitNodeModulesIncluded = (fileGlobs, fileNames) => {
    return !fileGlobs.some((glob) => glob.includes("node_modules")) && fileNames?.find((fileName) => fileName.includes("node_modules"));
};
//# sourceMappingURL=collectFileNames.js.map