"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeJavaScript = void 0;
const fs_1 = require("mz/fs");
const sources_1 = require("../sources");
const imports_1 = require("./imports");
const renames_1 = require("./renames");
const createJavaScriptConfig_1 = require("./createJavaScriptConfig");
const initializeJavaScript = async ({ fileName, project }) => {
    const sourceFiles = await sources_1.initializeSources({ fromJavaScript: true, project });
    const renames = await renames_1.initializeRenames();
    const imports = await imports_1.initializeImports();
    const settings = createJavaScriptConfig_1.createJavaScriptConfig({ imports, project, sourceFiles, renames });
    await fs_1.writeFile(fileName, JSON.stringify(settings, undefined, 4));
};
exports.initializeJavaScript = initializeJavaScript;
//# sourceMappingURL=index.js.map