"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeProject = void 0;
const enquirer_1 = require("enquirer");
const fs = __importStar(require("fs"));
const arrays_1 = require("../../shared/arrays");
const glob_1 = require("../../shared/glob");
const initializeNewProject_1 = require("./initializeNewProject");
const shared_1 = require("./shared");
const initializeProject = async () => {
    const project = await initializeBuiltInProject();
    return project === shared_1.TSConfigLocationSuggestion.Custom
        ? initializeCustomProject()
        : project === shared_1.TSConfigLocationSuggestion.DoesNotExist
            ? initializeNewProject_1.initializeNewProject()
            : { filePath: project };
};
exports.initializeProject = initializeProject;
const defaultSettings = {
    message: "Where is your tsconfig.json?",
    name: "project",
};
const initializeBuiltInProject = async () => {
    const choices = [
        ...arrays_1.uniquify(shared_1.TSConfigLocation.Root, shared_1.TSConfigLocation.UnderSrc, ...(await glob_1.globAllAsync(["./tsconfig*json", "./*/tsconfig*json"]))),
        shared_1.TSConfigLocationSuggestion.Custom,
        shared_1.TSConfigLocationSuggestion.DoesNotExist,
    ];
    const { project } = await enquirer_1.prompt([
        {
            ...defaultSettings,
            choices,
            initial: Math.max(0, [shared_1.TSConfigLocation.Root, shared_1.TSConfigLocation.UnderSrc].findIndex((choice) => fs.existsSync(choice))),
            type: "select",
        },
    ]);
    return project;
};
const initializeCustomProject = async () => {
    const { project } = await enquirer_1.prompt([
        {
            ...defaultSettings,
            initial: "./tsconfig.json",
            type: "text",
        },
    ]);
    return { filePath: project };
};
//# sourceMappingURL=index.js.map