"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeImprovements = exports.InitializationImprovement = void 0;
const enquirer_1 = require("enquirer");
var InitializationImprovement;
(function (InitializationImprovement) {
    InitializationImprovement["MissingProperties"] = "Add missing property declarations to classes";
    InitializationImprovement["NoImplicitAny"] = "Enable the --noImplicitAny compiler flag";
    InitializationImprovement["NoImplicitThis"] = "Enable the --noImplicitThis compiler flag";
    InitializationImprovement["NoInferableTypes"] = "Remove type annotations that don't change the meaning of code";
    InitializationImprovement["StrictNullChecks"] = "Enable the --strictNullChecks compiler flag";
})(InitializationImprovement = exports.InitializationImprovement || (exports.InitializationImprovement = {}));
const initializeImprovements = async () => {
    const choices = [
        InitializationImprovement.MissingProperties,
        InitializationImprovement.NoImplicitAny,
        InitializationImprovement.NoImplicitThis,
        InitializationImprovement.NoInferableTypes,
        InitializationImprovement.StrictNullChecks,
    ];
    const { improvements } = await enquirer_1.prompt([
        {
            choices,
            initial: 0,
            message: "Which improvements would you like to make?",
            name: "improvements",
            type: "multiselect",
        },
    ]);
    return improvements;
};
exports.initializeImprovements = initializeImprovements;
//# sourceMappingURL=improvements.js.map