"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeTypeScript = void 0;
const sources_1 = require("../sources");
const improvements_1 = require("./improvements");
const initializeTests_1 = require("./initializeTests");
const writeMultiTypeScriptConfig_1 = require("./writeMultiTypeScriptConfig");
const writeSingleTypeScriptConfig_1 = require("./writeSingleTypeScriptConfig");
const initializeTypeScript = async ({ fileName, project }) => {
    const improvements = new Set(await improvements_1.initializeImprovements());
    const sourceFiles = await sources_1.initializeSources({ fromJavaScript: false, project });
    if (!improvements.has(improvements_1.InitializationImprovement.StrictNullChecks)) {
        await writeSingleTypeScriptConfig_1.writeSingleTypeScriptConfig({ fileName, improvements, project, sourceFiles });
        return;
    }
    const testFiles = await initializeTests_1.initializeTests();
    await writeMultiTypeScriptConfig_1.writeMultiTypeScriptConfig({ fileName, improvements, project, sourceFiles, testFiles });
};
exports.initializeTypeScript = initializeTypeScript;
//# sourceMappingURL=index.js.map