"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeTests = void 0;
const enquirer_1 = require("enquirer");
const other = "other";
const initializeTests = async () => {
    const builtIn = await initializeBuiltInTests();
    return builtIn === other ? getCustomTests() : builtIn;
};
exports.initializeTests = initializeTests;
const initializeBuiltInTests = async () => {
    const choices = [
        "lib/**/__tests__/*.test.{ts,tsx}",
        "lib/**/*.test.{ts,tsx}",
        "src/**/__tests__/*.test.{ts,tsx}",
        "src/**/*.test.{ts,tsx}",
        "test/**/*.{ts,tsx}",
    ];
    const { testFiles } = await enquirer_1.prompt([
        {
            choices,
            initial: choices.length - 1,
            message: "Which glob matches your test files?",
            name: "testFiles",
            type: "select",
        },
    ]);
    return testFiles;
};
const getCustomTests = async () => {
    const { testFiles } = await enquirer_1.prompt([
        {
            initial: "test/**/*.{ts,tsx}",
            message: "Where are your test files?",
            name: "testFiles",
            type: "text",
        },
    ]);
    return testFiles;
};
//# sourceMappingURL=initializeTests.js.map