"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeSingleTypeScriptConfig = void 0;
const mz_1 = require("mz");
const improvements_1 = require("./improvements");
const writeSingleTypeScriptConfig = async ({ fileName, project, sourceFiles, improvements }) => {
    await mz_1.fs.writeFile(fileName, JSON.stringify({
        fixes: printImprovements(improvements),
        ...(sourceFiles && { include: [sourceFiles] }),
        projectPath: project.filePath,
    }, undefined, 4));
};
exports.writeSingleTypeScriptConfig = writeSingleTypeScriptConfig;
const printImprovements = (improvements) => {
    return {
        incompleteTypes: true,
        ...(improvements.has(improvements_1.InitializationImprovement.NoImplicitAny) && { noImplicitAny: true }),
        ...(improvements.has(improvements_1.InitializationImprovement.NoImplicitThis) && { noImplicitThis: true }),
    };
};
//# sourceMappingURL=writeSingleTypeScriptConfig.js.map