"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getNoImplicitThisMutations = void 0;
const creation_1 = require("./creation");
const getCodeFixIfMatchedByDiagnostic_1 = require("./getCodeFixIfMatchedByDiagnostic");
/**
 * Error code for the TypeScript language service to get --noImplicitThis code fixes.
 */
const noImplicitThisErrorCodes = [2683];
const getNoImplicitThisMutations = (node, request) => {
    // Create a mutation for the code fixes if anything is available
    const codeFixes = getCodeFixIfMatchedByDiagnostic_1.getCodeFixIfMatchedByDiagnostic(request, node, noImplicitThisErrorCodes);
    return !codeFixes?.length ? undefined : creation_1.createCodeFixCreationMutation(request, codeFixes);
};
exports.getNoImplicitThisMutations = getNoImplicitThisMutations;
//# sourceMappingURL=noImplicitThis.js.map