"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixIncompleteReactTypes = void 0;
const runtime_1 = require("../../../../shared/runtime");
const fixReactPropsFromLaterAssignments_1 = require("./fixReactPropsFromLaterAssignments");
const fixReactPropsFromUses_1 = require("./fixReactPropsFromUses");
const fixReactPropsFromPropTypes_1 = require("./fixReactPropsFromPropTypes");
const fixReactPropFunctionsFromCalls_1 = require("./fixReactPropFunctionsFromCalls");
const fixReactPropsMissing_1 = require("./fixReactPropsMissing");
const fixIncompleteReactTypes = (request) => runtime_1.findFirstMutations(request, [
    // Intentionally look at internal uses before later assignments,
    // as they're less likely to contain misleading type information
    ["fixReactPropsFromUses", fixReactPropsFromUses_1.fixReactPropsFromUses],
    ["fixReactPropsFromLaterAssignments", fixReactPropsFromLaterAssignments_1.fixReactPropsFromLaterAssignments],
    ["fixReactPropFunctionsFromCalls", fixReactPropFunctionsFromCalls_1.fixReactPropFunctionsFromCalls],
    // Use propTypes with lower priority than uses, assignments, and calls
    // In practical code they are often wrong
    ["fixReactPropsFromPropTypes", fixReactPropsFromPropTypes_1.fixReactPropsFromPropTypes],
    // Lastly, if the component is missing a props type altogether, create one from scratch
    ["fixReactPropsMissing", fixReactPropsMissing_1.fixReactPropsMissing],
]);
exports.fixIncompleteReactTypes = fixIncompleteReactTypes;
//# sourceMappingURL=index.js.map