"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseRawCompilerOptions = void 0;
const minimatch_1 = __importDefault(require("minimatch"));
const glob_1 = __importDefault(require("glob"));
const fs = __importStar(require("mz/fs"));
const path = __importStar(require("path"));
const ts = __importStar(require("typescript"));
const parseRawCompilerOptions = async (cwd, projectPath) => {
    const configRaw = (await fs.readFile(projectPath)).toString();
    const compilerOptions = ts.parseConfigFileTextToJson(projectPath, configRaw);
    if (compilerOptions.error !== undefined) {
        throw new Error(`Could not parse compiler options from '${projectPath}': ${typeof compilerOptions.error.messageText === "string"
            ? compilerOptions.error.messageText
            : compilerOptions.error.messageText.messageText}`);
    }
    const config = compilerOptions.config;
    // TSConfig includes often come in a glob form like ["src"]
    if (config.include) {
        config.include = ts.parseJsonConfigFileContent(compilerOptions.config, {
            useCaseSensitiveFileNames: true,
            readDirectory: (rootDir, extensions, excludes, includes) => includes
                .flatMap((include) => glob_1.default.sync(path.join(rootDir, include)))
                .filter((filePath) => !excludes?.some((exclude) => minimatch_1.default(filePath, exclude)) &&
                extensions.some((extension) => filePath.endsWith(extension)))
                .map((filePath) => path.relative(rootDir, filePath)),
            fileExists: (filePath) => fs.statSync(filePath).isFile(),
            readFile: (filePath) => fs.readFileSync(filePath).toString(),
        }, cwd).fileNames;
    }
    return config;
};
exports.parseRawCompilerOptions = parseRawCompilerOptions;
//# sourceMappingURL=parseRawCompilerOptions.js.map