"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTypeStatProvider = void 0;
const createProviderFromProviders_1 = require("./createProviderFromProviders");
const createCoreMutationsProvider_1 = require("./providers/createCoreMutationsProvider");
const createFileRenamesProvider_1 = require("./providers/createFileRenamesProvider");
const createInstallMissingTypesProvider_1 = require("./providers/createInstallMissingTypesProvider");
const createMarkFilesModifiedProvider_1 = require("./providers/createMarkFilesModifiedProvider");
const createPostProcessingProvider_1 = require("./providers/createPostProcessingProvider");
const createRequireRenameProvider_1 = require("./providers/createRequireRenameProvider");
/**
 * Creates a mutations provider that mutates files, then marks them as mutated.
 */
const createTypeStatProvider = (options) => {
    const allModifiedFiles = new Set();
    return {
        provide: createProviderFromProviders_1.createProviderFromProviders(options, [
            createFileRenamesProvider_1.createFileRenamesProvider(allModifiedFiles),
            createInstallMissingTypesProvider_1.createInstallMissingTypesProvider(),
            createRequireRenameProvider_1.createRequireRenameProvider(allModifiedFiles),
            createCoreMutationsProvider_1.createCoreMutationsProvider(allModifiedFiles),
            createMarkFilesModifiedProvider_1.createMarkFilesModifiedProvider(allModifiedFiles),
            createPostProcessingProvider_1.createPostProcessingProvider(allModifiedFiles),
        ]),
    };
};
exports.createTypeStatProvider = createTypeStatProvider;
//# sourceMappingURL=createTypeStatProvider.js.map