"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findMutationsInFile = void 0;
const os_1 = require("os");
const complaint_1 = require("../mutators/complaint");
const runtime_1 = require("../shared/runtime");
/**
 * Collects all mutations that should apply to a file.
 */
const findMutationsInFile = (request) => {
    let mutations = runtime_1.findFirstMutations(request, request.options.mutators);
    if (mutations instanceof complaint_1.MutationsComplaint) {
        request.options.output.stderr(`${os_1.EOL}Error in ${request.sourceFile.fileName} with ${mutations.mutatorPath.join(" > ")}: ${mutations.error.stack || mutations.error.message}${os_1.EOL}${os_1.EOL}`);
        mutations = undefined;
    }
    return mutations;
};
exports.findMutationsInFile = findMutationsInFile;
//# sourceMappingURL=findMutationsInFile.js.map