"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getNewFileName = void 0;
const getNewFileName = async (renameExtensions, oldFileName, readFile) => {
    const oldExtension = oldFileName.substring(oldFileName.lastIndexOf("."));
    const beforeExtension = oldFileName.substring(0, oldFileName.length - oldExtension.length);
    if (typeof renameExtensions === "string") {
        return `${beforeExtension}.${renameExtensions}`;
    }
    const fileContents = (await readFile(oldFileName)).toString();
    const fileContentsJoined = fileContents.replace(/ /g, "").replace(/"/g, "'");
    if (/(<\s*\/\s*[A-z\.]*\s*>)|(\/\s*>)/.test(fileContentsJoined)) {
        return `${beforeExtension}.tsx`;
    }
    return `${beforeExtension}.ts`;
};
exports.getNewFileName = getNewFileName;
//# sourceMappingURL=getNewFileName.js.map