"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.filterTypedPackageNames = void 0;
const https = __importStar(require("https"));
/**
 * Removes package names that don't have a corresponding DefinitelyTyped package.
 *
 * @param packageNames   Package names to filter.
 * @returns Promise for just the package names with a corresponding DefinitelyTyped package.
 */
const filterTypedPackageNames = async (packageNames) => {
    const processedPackageNames = await Promise.all(packageNames.map(filterTypedPackageName));
    return processedPackageNames.filter((packageName) => packageName !== undefined);
};
exports.filterTypedPackageNames = filterTypedPackageNames;
const filterTypedPackageName = async (packageName) => {
    return new Promise((resolve) => {
        https.get(`https://www.npmjs.com/package/@types/${packageName}`, (result) => {
            resolve(result.statusCode === 200 ? packageName : undefined);
        });
    });
};
//# sourceMappingURL=filterTypedPackageNames.js.map