"use strict";
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _WaveTracker_previouslySeen, _WaveTracker_repeatedCount;
Object.defineProperty(exports, "__esModule", { value: true });
exports.WaveTracker = exports.infiniteWaveThreshold = void 0;
const createHash = (fileMutations) => Object.keys(fileMutations).join(",");
/**
 * How many waves in a row must be duplicates of previously seen waves to halt.
 */
exports.infiniteWaveThreshold = 20;
class WaveTracker {
    constructor() {
        /**
         * How many times each wave file names hash has been seen.
         */
        _WaveTracker_previouslySeen.set(this, new Set());
        /**
         * How many waves in a row have now had repetitions greater than the duplicate threshold.
         */
        _WaveTracker_repeatedCount.set(this, 0);
    }
    /**
     * @param fileMutations A newly created wave of mutations.
     * @returns Whether the wave has reached the duplicate threshold.
     */
    addAndCheck(fileMutations) {
        const hash = createHash(fileMutations);
        const previouslySeen = __classPrivateFieldGet(this, _WaveTracker_previouslySeen, "f").has(hash);
        __classPrivateFieldGet(this, _WaveTracker_previouslySeen, "f").add(hash);
        if (!previouslySeen) {
            __classPrivateFieldSet(this, _WaveTracker_repeatedCount, 0, "f");
            return false;
        }
        __classPrivateFieldSet(this, _WaveTracker_repeatedCount, __classPrivateFieldGet(this, _WaveTracker_repeatedCount, "f") + 1, "f");
        return __classPrivateFieldGet(this, _WaveTracker_repeatedCount, "f") === exports.infiniteWaveThreshold;
    }
}
exports.WaveTracker = WaveTracker;
_WaveTracker_previouslySeen = new WeakMap(), _WaveTracker_repeatedCount = new WeakMap();
//# sourceMappingURL=WaveTracker.js.map