"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getQuickErrorSummary = void 0;
/* eslint-disable @typescript-eslint/restrict-template-expressions */
const getQuickErrorSummary = (error, stackTraceLimit = Infinity) => {
    if (!(error instanceof Error) || error.stack === undefined) {
        return `${error}`;
    }
    const lines = error.stack.split("\n");
    let output = lines.slice(0, stackTraceLimit).join("\n\t");
    if (lines.length > stackTraceLimit) {
        output += "\n\t    ...";
    }
    return output;
};
exports.getQuickErrorSummary = getQuickErrorSummary;
//# sourceMappingURL=errors.js.map